// BEGIN TINYHOST DATASTORE SECTION
//
// All the code in this block is autogenerated by tinyhost and added to your static html page
// in order to support a simple datastore backed by AWS S3.
// 
// Please don't change anything here by hand
// If it's not working, try running tinyhost again and getting a fresh link

const datastoreId = "{{ datastore_id }}";
const presignedGetUrl = "{{ presigned_get_url }}";
const presignedPostDict = {{ presigned_post_dict }};


// Fetch state from the S3-backed datastore
async function fetchDatastore() {
    try {
        const response = await fetch(presignedGetUrl, {
            method: 'GET',
            cache: 'no-store',
        });
        if (!response.ok) {
            throw new Error('Failed to fetch the file.');
        }
        return await response.json();
    } catch (error) {
        console.error('Error fetching tinyhost state from S3:', error);
    }
}

// Write data to the S3-backed datastore
async function putDatastore(data) {
    try {
        // Create a FormData object to hold the necessary fields for the POST request
        const formData = new FormData();

        // Add fields provided by the presignedPostDict to the FormData object
        for (const [key, value] of Object.entries(presignedPostDict.fields)) {
            formData.append(key, value);
        }

        // Convert the data to JSON and append it as the file to be uploaded
        const jsonData = new Blob([JSON.stringify(data)], { type: 'application/json' });
        formData.append('file', jsonData);

        // Make the POST request to upload the data
        const response = await fetch(presignedPostDict.url, {
            method: 'POST',
            body: formData
        });

        if (!response.ok) {
            throw new Error('Failed to upload the file.');
        }

        console.log('Datastore successfully updated.');
    } catch (error) {
        console.error('Error putting tinyhost state to S3:', error);
    }
}


// END TINYHOST DATASTORE SECTION 
